"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _utils = require("./utils");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var VEUI_PACKAGE_NAME = 'veui';
var COMPONENTS_DIRNAME = 'components';

function _default(_ref) {
  var t = _ref.types;
  return {
    name: 'veui',
    visitor: {
      ImportDeclaration: function ImportDeclaration(path, _ref2) {
        var _ref2$opts = _ref2.opts,
            opts = _ref2$opts === void 0 ? {} : _ref2$opts;
        var node = path.node;
        var _opts$alias = opts.alias,
            alias = _opts$alias === void 0 ? VEUI_PACKAGE_NAME : _opts$alias;
        var src = (0, _utils.normalize)(node.source.value);

        if (src === alias) {
          if (node.specifiers.length === 1 && (node.specifiers[0].type === 'ImportDefaultSpecifier' || node.specifiers[0].type === 'ImportNamespaceSpecifier')) {
            return;
          }

          var newImports = node.specifiers.map(function (_ref3) {
            var imported = _ref3.imported,
                local = _ref3.local;

            if (imported.name === 'default') {
              return t.importDeclaration([t.importDefaultSpecifier(t.identifier(local.name))], t.stringLiteral(src));
            } else {
              var realName = getComponentName(imported.name);
              var componentSrc = getComponentPath(realName, alias);

              if (!componentSrc) {
                throw new Error("[".concat(realName, "] is not a valid component in VEUI."));
              }

              var name = local.name || imported.name;
              return t.importDeclaration([t.importDefaultSpecifier(t.identifier(name))], t.stringLiteral(componentSrc));
            }
          });
          path.replaceWithMultiple(newImports);
        }
      }
    }
  };
}

var VAR_PATTERN = /(?:V(?:eui)?)?([A-Z][a-zA-Z]*)/;

function getComponentName(importedName) {
  var _importedName$match = importedName.match(VAR_PATTERN),
      _importedName$match2 = _slicedToArray(_importedName$match, 2),
      name = _importedName$match2[1];

  return name || null;
}

function getComponentPath(componentName, alias) {
  var components = require("".concat(alias, "/components.json"));

  var entry = components.find(function (_ref4) {
    var name = _ref4.name;
    return name === componentName;
  });

  if (!entry) {
    return null;
  }

  return "".concat(alias, "/").concat(COMPONENTS_DIRNAME, "/").concat(entry.path);
}